using System;
using System.IO;

namespace Siberix.Examples
{
	class Example
	{
		static void Main(string[] args)
		{
			// Report
			Siberix.Report.Report report = new Siberix.Report.Report();

			// Info
			report.Info.Title = "Example";
			report.Info.Author = "Siberix Technologies, Canada";
			report.Info.Creator = "Siberix Report Writer";
			report.Info.Copyright = "2003-2012 Siberix Technologies, Canada";

			// Section
			Siberix.Report.Section.ISection section = report.AddSection();
			section.Size = Siberix.Report.PageSize.Letter;
			section.Spacings.All = 35;

			// Styles
			Siberix.Report.Text.Style style1 = new Siberix.Report.Text.Style(new Siberix.Graphics.Fonts.Arial(12), Siberix.Graphics.Brushes.Black);

			// Shapes
			Siberix.Report.ISite site = section.AddSite();

			// Rectangle
			Siberix.Report.Shapes.IRectangle rectangle = site.Shapes.AddRectangle();
			rectangle.Pen = new Siberix.Graphics.Pen(Siberix.Graphics.Colors.Red, 5);
			rectangle.Brush = new Siberix.Graphics.SolidColorBrush(new Siberix.Graphics.Color(255, 240, 240));
			rectangle.X = 30;
			rectangle.Y = 30;
			rectangle.Width = 150;
			rectangle.Height = 100;
			rectangle.Radius = 5;
			rectangle.Angle = 15;

			Siberix.Report.Shapes.ILabel label = site.Shapes.AddLabel();
			label.Font = style1.Font;
			label.Brush = Siberix.Graphics.Brushes.Black;
			label.X = 60;
			label.Y = 30;
			label.Text = "Rectangle";
			label.Angle = 15;

			// Line
			Siberix.Report.Shapes.ILine line = site.Shapes.AddLine();
			line.Pen = new Siberix.Graphics.Pen(Siberix.Graphics.Colors.Green, 5);
			line.X1 = 220;
			line.Y1 = 30;
			line.X2 = 320;
			line.Y2 = 130;

			label = site.Shapes.AddLabel();
			label.Font = style1.Font;
			label.Brush = Siberix.Graphics.Brushes.Black;
			label.X = 250;
			label.Y = 35;
			label.Text = "Line";
			label.Angle = 45;

			// Ellipse
			Siberix.Report.Shapes.IEllipse ellipse = site.Shapes.AddEllipse();
			ellipse.Pen = new Siberix.Graphics.Pen(Siberix.Graphics.Colors.Blue, 5);
			ellipse.Brush = new Siberix.Graphics.SolidColorBrush(new Siberix.Graphics.Color(240, 240, 255));
			ellipse.X = 350;
			ellipse.Y = 30;
			ellipse.Width = 150;
			ellipse.Height = 100;
			ellipse.Angle = -20;

			label = site.Shapes.AddLabel();
			label.Font = style1.Font;
			label.Brush = Siberix.Graphics.Brushes.Black;
			label.X = 400;
			label.Y = 80;
			label.Text = "Ellipse";
			label.Angle = -20;

			// Polyline
			Siberix.Report.Shapes.IPolyline polyline = site.Shapes.AddPolyline();
			polyline.Pen = new Siberix.Graphics.Pen(Siberix.Graphics.Colors.Green, 5, Siberix.Graphics.DashStyle.DashDot);

			Siberix.Graphics.PointCollection points = new Siberix.Graphics.PointCollection();
			points.Add(30, 200);
			points.Add(185, 220);
			points.Add(150, 350);
			points.Add(125, 260);
			points.Add(70, 300);
			polyline.Points = points;

			label = site.Shapes.AddLabel();
			label.Font = style1.Font;
			label.Brush = Siberix.Graphics.Brushes.Black;
			label.X = 70;
			label.Y = 220;
			label.Text = "Polyline";
			label.Angle = 5;

			// Polygon
			Siberix.Report.Shapes.IPolygon polygon = site.Shapes.AddPolygon();
			polygon.Pen = new Siberix.Graphics.Pen(Siberix.Graphics.Colors.Goldenrod, 5);
			polygon.Brush = new Siberix.Graphics.SolidColorBrush(new Siberix.Graphics.Color(250, 250, 245));
			points = new Siberix.Graphics.PointCollection();
			points.Add(230, 200);
			points.Add(385, 220);
			points.Add(350, 350);
			points.Add(270, 300);
			polygon.Points = points;

			label = site.Shapes.AddLabel();
			label.Font = style1.Font;
			label.Brush = Siberix.Graphics.Brushes.Black;
			label.X = 270;
			label.Y = 220;
			label.Text = "Polygon";
			label.Angle = 5;

			// Pie
			Siberix.Report.Shapes.IPie pie = site.Shapes.AddPie();
			pie.Pen = new Siberix.Graphics.Pen(Siberix.Graphics.Colors.DarkOrchid, 5);
			pie.Brush = new Siberix.Graphics.SolidColorBrush(new Siberix.Graphics.Color(250, 230, 250));
			pie.X = 400;
			pie.Y = 230;
			pie.Width = 100;
			pie.Height = 100;
			pie.StartAngle = -45;
			pie.EndAngle = 265;

			label = site.Shapes.AddLabel();
			label.Font = style1.Font;
			label.Brush = Siberix.Graphics.Brushes.Black;
			label.X = 450;
			label.Y = 290;
			label.Text = "Pie";
			label.Angle = -40;

			// Path
			Siberix.Report.Shapes.IPath path = site.Shapes.AddPath();
			path.Pen = new Siberix.Graphics.Pen(Siberix.Graphics.Colors.DarkBlue, 5, Siberix.Graphics.DashStyle.DashDotDot);
			path.Brush = new Siberix.Graphics.SolidColorBrush(new Siberix.Graphics.Color(250, 250, 245));
			path.MoveTo(100, 400);
			path.LineTo(300, 500);
			path.CurveTo(120, 560, 100, 520, 70, 480);
			path.CurveTo(320, 360, 200, 320, 150, 600);
			path.ClosePath();

			label = site.Shapes.AddLabel();
			label.Font = style1.Font;
			label.Brush = Siberix.Graphics.Brushes.Black;
			label.X = 140;
			label.Y = 460;
			label.Text = "Path";

			// Arc
			Siberix.Report.Shapes.IArc arc = site.Shapes.AddArc();
			arc.Pen = new Siberix.Graphics.Pen(Siberix.Graphics.Colors.Red, 5);
			arc.X = 370;
			arc.Y = 420;
			arc.Width = 100;
			arc.Height = 100;
			arc.StartAngle = -45;
			arc.EndAngle = 265;

			label = site.Shapes.AddLabel();
			label.Font = style1.Font;
			label.Brush = Siberix.Graphics.Brushes.Black;
			label.X = 430;
			label.Y = 415;
			label.Text = "Arc";
			label.Angle = 15;

			// Publish
			report.Publish("Document.pdf", Siberix.Report.FileFormat.PDF);
			report.Publish("Document.xps", Siberix.Report.FileFormat.XPS);

			// Save
			report.Save("Document.xml");

			// View
			System.Diagnostics.Process process = new System.Diagnostics.Process();
			System.Diagnostics.ProcessStartInfo info = new System.Diagnostics.ProcessStartInfo("Document.pdf");
			process.StartInfo = info;
			process.Start();
		}
	}
}