using System;
using System.IO;

namespace Siberix.Examples
{
	class Example
	{
		static void Main(string[] args)
		{
			// Report
			Siberix.Report.Report report = new Siberix.Report.Report();

			// Info
			report.Info.Title = "Example";
			report.Info.Author = "Siberix Technologies, Canada";
			report.Info.Creator = "Siberix Report Writer";
			report.Info.Copyright = "2003-2012 Siberix Technologies, Canada";

			// Section
			Siberix.Report.Section.ISection section = report.AddSection();
			section.Size = Siberix.Report.PageSize.Letter;
			section.Spacings.All = 35;

			// Styles
			Siberix.Report.Text.Style style1 = new Siberix.Report.Text.Style(new Siberix.Graphics.Fonts.Arial(12), Siberix.Graphics.Brushes.Black);
			Siberix.Report.Text.Style style2 = new Siberix.Report.Text.Style(new Siberix.Graphics.Fonts.Arial(12), Siberix.Graphics.Brushes.Red);

			// Tree
			Siberix.Report.Tree.ITree tree = section.AddTree();
			tree.Indent = 20;
			tree.Interval = 10;
			tree.Lines.Pen = Siberix.Graphics.Pens.DarkBlue;

			Siberix.Report.Text.IText text = tree.AddText();
			text.Style = style1;
			text.AddContent("Root", style2);

			Siberix.Report.Tree.INode node = tree.AddNode();

			text = node.AddText();
			text.Style = style1;
			text.AddContent("Node ");
			text.AddContent("1", style2);

			node = tree.AddNode();

			text = node.AddText();
			text.Style = style1;
			text.AddContent("Node ");
			text.AddContent("2", style2);

			node = node.AddNode();

			text = node.AddText();
			text.Style = style1;
			text.AddContent("Node ");
			text.AddContent("2.1", style2);

			node = tree.AddNode();

			text = node.AddText();
			text.Style = style1;
			text.AddContent("Node ");
			text.AddContent("3", style2);

			// Publish
			report.Publish("Document.pdf", Siberix.Report.FileFormat.PDF);
			report.Publish("Document.xps", Siberix.Report.FileFormat.XPS);

			// Save
			report.Save("Document.xml");

			// View
			System.Diagnostics.Process process = new System.Diagnostics.Process();
			System.Diagnostics.ProcessStartInfo info = new System.Diagnostics.ProcessStartInfo("Document.pdf");
			process.StartInfo = info;
			process.Start();
		}
	}
}