Module Example

    Sub Main()

        ' Report
        Dim report As Siberix.Report.Report = New Siberix.Report.Report()

        ' Callback
        report.Callback = New Callback()

        ' Load
        report.Load("../../Example.xml")

        ' Publish
        report.Publish("Document.pdf", Siberix.Report.FileFormat.PDF)
        report.Publish("Document.xps", Siberix.Report.FileFormat.XPS)

        ' View
        Dim process As System.Diagnostics.Process = New System.Diagnostics.Process()
        Dim info As System.Diagnostics.ProcessStartInfo = New System.Diagnostics.ProcessStartInfo("Document.pdf")
        process.StartInfo = info
        process.Start()

    End Sub

    Public Class Callback
        Implements Siberix.Report.ICallback

        Public Function OnMergeCode(ByVal id As String) As String Implements Siberix.Report.ICallback.OnMergeCode

            If id = Nothing Then
                Return Nothing
            End If

            If id.Equals("Company") Then
                Return "Siberix Technologies"
            End If

            Return Nothing

        End Function

        Public Sub OnInjector(ByVal id As String, ByVal element As Siberix.Report.IElement) Implements Siberix.Report.ICallback.OnInjector

            If (element Is Nothing) Or (id = Nothing) Then
                Return
            End If

            If (element.Type = Siberix.Report.ElementType.Group) And id.Equals("Injector1") Then

                Dim group As Siberix.Report.IGroup = CType(element, Siberix.Report.IGroup)

                Dim text As Siberix.Report.Text.IText = group.AddText()
                text.Style = New Siberix.Report.Text.Style(New Siberix.Graphics.Fonts.Arial(12), Siberix.Graphics.Brushes.DarkGreen)
                text.Spacings.Bottom = 5
                text.AddContent("Group's injector test!")

            End If

        End Sub

        Public Sub OnInjector(ByVal id As String, ByVal text As Siberix.Report.Text.IText, ByVal style As Siberix.Report.Text.Style, ByVal hyperlink As Siberix.Report.Text.Hyperlink) Implements Siberix.Report.ICallback.OnInjector

            If (id = Nothing) Then
                Return
            End If

            If id.Equals("UserName") Then

                If style Is Nothing Then
                    style = New Siberix.Report.Text.Style(Nothing, Siberix.Graphics.Brushes.Blue)
                Else
                    style = New Siberix.Report.Text.Style(style.Font, Siberix.Graphics.Brushes.Blue)
                End If

                text.AddContent("John", style)

            End If

        End Sub

        Public Function ResolvePath(ByVal path As String) As String Implements Siberix.Report.ICallback.ResolvePath

            Return path

        End Function

        Public Function GetStyle(ByVal id As String) As Siberix.Report.Text.Style Implements Siberix.Report.ICallback.GetStyle

            Return Nothing

        End Function

        Public Function LoadFont(ByVal path As String) As System.IO.Stream Implements Siberix.Report.ICallback.LoadFont

            Return Nothing

        End Function

        Public Function LoadImage(ByVal path As String) As System.IO.Stream Implements Siberix.Report.ICallback.LoadImage

            Return Nothing

        End Function

        Public Function LoadMetafile(ByVal path As String) As System.IO.Stream Implements Siberix.Report.ICallback.LoadMetafile

            Return Nothing

        End Function

        Public Function OnDrawing(ByVal id As String) As Siberix.Report.IDrawing Implements Siberix.Report.ICallback.OnDrawing

            Return Nothing

        End Function

        Public Sub OnLoadEnd(ByVal element As Siberix.Report.IElement) Implements Siberix.Report.ICallback.OnLoadEnd

        End Sub

        Public Sub OnLoadStart(ByVal element As Siberix.Report.IElement) Implements Siberix.Report.ICallback.OnLoadStart

        End Sub

    End Class

End Module
