Imports System
Imports System.Collections.Generic

Module Example
    Private Class Person

        Public Sub New()

        End Sub

        Public Property Name As String
        Public Property Birthday As DateTime
        Public Property Level As Integer
        Public Property Tasks As List(Of Task)

    End Class

    Private Class Task

        Public Sub New()

        End Sub

        Public Property Id As String
        Public Property Description As String

    End Class

    Private Class ValueFormatter1
        Implements Siberix.Report.Data.IValueFormatter

        Public Sub New()

        End Sub

        Public ReadOnly Property Id() As String Implements Siberix.Report.Data.IValueFormatter.Id

            Get
                Return "vf1"
            End Get

        End Property

        Public Function Format(ByVal value As Object) As String Implements Siberix.Report.Data.IValueFormatter.Format

            If value <> Nothing Then

                Dim dt As DateTime = CType(value, DateTime)

                Return "[ " + dt.Year.ToString() + " / " + dt.ToString("MMM") + " / " + dt.Day.ToString() + " ]"

            End If

            Return Nothing

        End Function

    End Class

    Private Class ValueFormatter2
        Implements Siberix.Report.Data.IValueFormatter

        Public Sub New()

        End Sub

        Public ReadOnly Property Id() As String Implements Siberix.Report.Data.IValueFormatter.Id

            Get
                Return "vf2"
            End Get

        End Property

        Public Function Format(ByVal value As Object) As String Implements Siberix.Report.Data.IValueFormatter.Format

            If value <> Nothing Then
                Return "< " + CType(value, String) + " >"
            End If

            Return Nothing

        End Function

    End Class

    Private Class TemplateSelector1
        Implements Siberix.Report.List.IItemTemplateSelector

        Public ReadOnly Property Id As String Implements Siberix.Report.Data.ITemplateSelector.Id

            Get
                Return "ts1"
            End Get

        End Property

        Public Function SelectItemTemplate(ByVal item As Object, ByVal index As Integer, ByVal templates As System.Collections.Generic.List(Of Siberix.Report.List.IItemTemplate), ByVal factory As Siberix.Report.List.IItemTemplateFactory) As Siberix.Report.List.IItemTemplate Implements Siberix.Report.List.IItemTemplateSelector.SelectItemTemplate

            If index = 1 Then
                Return templates(1)
            End If

            If index = 3 Then

                Dim style1 As Siberix.Report.Text.Style = New Siberix.Report.Text.Style(New Siberix.Graphics.Fonts.Arial(15), Siberix.Graphics.Brushes.Blue)

                Dim template As Siberix.Report.List.IItemTemplate = factory.CreateItemTemplate()

                Dim text As Siberix.Report.Text.IText = template.AddText()
                text.Binding = New Siberix.Report.Data.DataBinding("Description", "New Item Template: {0}")
                text.Style = style1

                Return template

            End If

            Return templates(0)

        End Function

    End Class

    Private Class TemplateSelector2
        Implements Siberix.Report.Grid.IRowTemplateSelector

        Public ReadOnly Property Id As String Implements Siberix.Report.Data.ITemplateSelector.Id

            Get
                Return "ts2"
            End Get

        End Property


        Public Function SelectRowTemplate(ByVal item As Object, ByVal index As Integer, ByVal templates As System.Collections.Generic.List(Of Siberix.Report.Grid.IRowTemplate), ByVal factory As Siberix.Report.Grid.IRowTemplateFactory) As Siberix.Report.Grid.IRowTemplate Implements Siberix.Report.Grid.IRowTemplateSelector.SelectRowTemplate

            If index = 1 Then
                Return templates(1)
            End If


            If index = 3 Then

                Dim style1 As Siberix.Report.Text.Style = New Siberix.Report.Text.Style(New Siberix.Graphics.Fonts.Arial(14), Siberix.Graphics.Brushes.Blue)
                Dim style2 As Siberix.Report.Text.Style = New Siberix.Report.Text.Style(New Siberix.Graphics.Fonts.Arial(14), Siberix.Graphics.Brushes.White)

                Dim template As Siberix.Report.Grid.IRowTemplate = factory.CreateRowTemplate()

                Dim cell As Siberix.Report.Grid.ICell = template.AddCell()
                cell.Borders = New Siberix.Report.Borders(Siberix.Graphics.Pens.Black)
                cell.Paddings.All = 5

                Dim text As Siberix.Report.Text.IText = cell.AddText()
                text.Binding = New Siberix.Report.Data.DataBinding("Id", "{0}")
                text.Style = style1

                cell = template.AddCell()
                cell.Borders = New Siberix.Report.Borders(Siberix.Graphics.Pens.Black)
                cell.Paddings.All = 5
                cell.Background.Brush = Siberix.Graphics.Brushes.YellowGreen

                text = cell.AddText()
                text.Binding = New Siberix.Report.Data.DataBinding("Description", "New Row Template: {0}")
                text.Style = style2

                Return template

            End If

            Return templates(0)

        End Function

    End Class

    Sub Main()
        Dim myReport As MyReport = New MyReport()

        myReport.GenerateReport()

        ' View
        Dim process As System.Diagnostics.Process = New System.Diagnostics.Process()
        Dim info As System.Diagnostics.ProcessStartInfo = New System.Diagnostics.ProcessStartInfo("Document.pdf")
        process.StartInfo = info
        process.Start()

    End Sub

    Private Class MyReport
        Implements Siberix.Report.Data.IDataProvider

        Private _dc1 As Siberix.Report.Data.IDataContext
        Private _dc2 As Siberix.Report.Data.IDataContext
        Private _dc3 As Siberix.Report.Data.IDataContext
        Private _dc4 As Siberix.Report.Data.IDataContext
        Private _dc5 As Siberix.Report.Data.IDataContext
        Private _vf1 As Siberix.Report.Data.IValueFormatter
        Private _vf2 As Siberix.Report.Data.IValueFormatter
        Private _ts1 As Siberix.Report.Data.ITemplateSelector
        Private _ts2 As Siberix.Report.Data.ITemplateSelector

        Public Function GetDataContext(ByVal id As String) As Siberix.Report.Data.IDataContext Implements Siberix.Report.Data.IDataProvider.GetDataContext

            If String.IsNullOrEmpty(id) Then
                Return Nothing
            End If

            Select Case (id)

                Case "dc1"
                    Return _dc1

                Case "dc2"
                    Return _dc2

                Case "dc3"
                    Return _dc3

                Case "dc4"
                    Return _dc4

                Case "dc5"
                    Return _dc5

            End Select

            Return Nothing

        End Function

        Public Function GetTemplateSelector(ByVal id As String) As Siberix.Report.Data.ITemplateSelector Implements Siberix.Report.Data.IDataProvider.GetTemplateSelector

            If String.IsNullOrEmpty(id) Then
                Return Nothing
            End If

            If id.Equals("ts1") Then
                Return _ts1
            End If

            If id.Equals("ts2") Then
                Return _ts2
            End If

            Return Nothing

        End Function

        Public Function GetValueFormatter(ByVal id As String) As Siberix.Report.Data.IValueFormatter Implements Siberix.Report.Data.IDataProvider.GetValueFormatter

            If String.IsNullOrEmpty(id) Then
                Return Nothing
            End If

            If id.Equals("vf1") Then
                Return _vf1
            End If

            If id.Equals("vf2") Then
                Return _vf2
            End If

            Return Nothing

        End Function

        Public Sub GenerateReport()

            Dim person1 As Person = New Person() With {.Name = "John", .Level = 3}
            Dim person2 As Person = New Person() With {.Name = "Alex", .Level = 2}
            Dim person3 As Person = New Person() With {.Name = "Bob", .Level = 7}
            Dim person4 As Person = New Person() With {.Name = "Scott", .Level = 1, .Birthday = New DateTime(1965, 10, 23)}

            Dim tasks As List(Of Task) = New List(Of Task)

            tasks.Add(New Task() With {.Id = "1-A11", .Description = "Task 1"})
            tasks.Add(New Task() With {.Id = "2-B22", .Description = "Task 2"})
            tasks.Add(New Task() With {.Id = "3-C33", .Description = "Task 3"})
            tasks.Add(New Task() With {.Id = "4-D44", .Description = "Task 4"})
            tasks.Add(New Task() With {.Id = "5-E55", .Description = "Task 5"})

            Dim person5 As Person = New Person() With {.Name = "Nick", .Level = 1, .Birthday = New DateTime(1975, 7, 16), .Tasks = tasks}

            _dc1 = New Siberix.Report.Data.DataContext("dc1", person4)
            _dc2 = New Siberix.Report.Data.DataContext("dc2", person1)
            _dc3 = New Siberix.Report.Data.DataContext("dc3", person3)
            _dc4 = New Siberix.Report.Data.DataContext("dc4", person2)
            _dc5 = New Siberix.Report.Data.DataContext("dc5", person5)

            _vf1 = New ValueFormatter1()
            _vf2 = New ValueFormatter2()

            _ts1 = New TemplateSelector1()
            _ts2 = New TemplateSelector2()

            ' Report
            Dim report As Siberix.Report.Report = New Siberix.Report.Report()

            report.DataProvider = Me

            ' Load
            Report.Load("../../Report.xml")

            ' Publish
            report.Publish("Document.pdf", Siberix.Report.FileFormat.PDF)
            report.Publish("Document.xps", Siberix.Report.FileFormat.XPS)

        End Sub

    End Class

End Module
