Imports System
Imports System.Collections.Generic

Module Example

    Private Class Task

        Public Sub New()

        End Sub

        Public Property Id As String
        Public Property Description As String

    End Class

    Private Class TemplateSelector
        Implements Siberix.Report.Repeater.IItemTemplateSelector

        Public ReadOnly Property Id As String Implements Siberix.Report.Data.ITemplateSelector.Id

            Get
                Return "ts1"
            End Get

        End Property


        Public Function SelectItemTemplate(ByVal item As Object, ByVal index As Integer, ByVal templates As System.Collections.Generic.List(Of Siberix.Report.Repeater.IItemTemplate), ByVal factory As Siberix.Report.Repeater.IItemTemplateFactory) As Siberix.Report.Repeater.IItemTemplate Implements Siberix.Report.Repeater.IItemTemplateSelector.SelectItemTemplate

            If (index + 1) Mod 5 = 0 Then
                Return templates(1)
            End If

            Return templates(0)

        End Function

    End Class

    Sub Main()

        Dim tasks As List(Of Task) = New List(Of Task)

        For i As Integer = 1 To 26
            tasks.Add(New Task() With {.Id = i.ToString(), .Description = i.ToString() + ". Amarone is produced in the Veneto region of northern Italy using a unique winemaking technique. Newly harvested grapes are laid on straw mats and left to dry over the course of several months - resulting in a wine with a very distinctive ""raisiny"" flavor"})
        Next

        Dim ts1 As TemplateSelector = New TemplateSelector()

        ' Report
        Dim report As Siberix.Report.Report = New Siberix.Report.Report()

        report.DataContext = New Siberix.Report.Data.DataContext("dc1", tasks)

        report.Delegates.GetTemplateSelectorDelegate = Function(id As String)
                                                           If id = ts1.Id Then
                                                               Return ts1
                                                           End If

                                                           Return Nothing

                                                       End Function

        ' Load
        report.Load("../../Report.xml")

        ' Publish
        report.Publish("Document.pdf", Siberix.Report.FileFormat.PDF)
        report.Publish("Document.xps", Siberix.Report.FileFormat.XPS)

        ' View
        Dim process As System.Diagnostics.Process = New System.Diagnostics.Process()
        Dim info As System.Diagnostics.ProcessStartInfo = New System.Diagnostics.ProcessStartInfo("Document.pdf")
        process.StartInfo = info
        process.Start()

    End Sub

End Module
