Imports System
Imports System.Collections.Generic

Module Example

    Public Class Action
        Public Sub New()

        End Sub

        Public Sub DoAction(ByVal element As Siberix.Report.IElement)

            CType(element, Siberix.Report.Text.IText).AddContent("...Action!")

        End Sub

    End Class

    Sub Main()

        ' Report
        Dim report As Siberix.Report.Report = New Siberix.Report.Report()

        ' Info
        report.Info.Title = "Example"
        report.Info.Author = "Siberix Technologies, Canada"
        report.Info.Creator = "Siberix Report Writer"
        report.Info.Copyright = "2003-2012 Siberix Technologies, Canada"

        ' Section
        Dim section As Siberix.Report.Section.ISection = report.AddSection()
        section.Size = Siberix.Report.PageSize.Letter
        section.Spacings.All = 35

        ' Styles
        Dim style1 As Siberix.Report.Text.Style = New Siberix.Report.Text.Style(New Siberix.Graphics.Fonts.Arial(12), Siberix.Graphics.Brushes.Black)

        For i As Integer = 1 To 50

            Dim text As Siberix.Report.Text.IText = section.AddText()
            text.Id = "Id" + i.ToString()
            text.Style = style1
            text.AddContent("Item " + i.ToString())

        Next

        Dim c As ICollection(Of Siberix.Report.IElement) = section.Select(Function(element)

                                                                              If (element.Type = Siberix.Report.ElementType.Text) And element.Id.EndsWith("5") Then
                                                                                  Return True
                                                                              Else
                                                                                  Return False
                                                                              End If

                                                                          End Function)

        For Each element As Siberix.Report.IElement In c
            CType(element, Siberix.Report.Text.IText).AddContent("...5th Element!")
        Next

        Dim action As Action = New Action()

        section.Perform(Function(element)

                            If (element.Type = Siberix.Report.ElementType.Text) And element.Id.StartsWith("Id3") Then
                                Return True
                            Else
                                Return False
                            End If

                        End Function, AddressOf action.DoAction)

        ' Publish
        report.Publish("Document.pdf", Siberix.Report.FileFormat.PDF)
        report.Publish("Document.xps", Siberix.Report.FileFormat.XPS)

        ' Save
        report.Save("Report.xml")

        ' View
        Dim process As System.Diagnostics.Process = New System.Diagnostics.Process()
        Dim info As System.Diagnostics.ProcessStartInfo = New System.Diagnostics.ProcessStartInfo("Document.pdf")
        process.StartInfo = info
        process.Start()

    End Sub

End Module
