Imports System
Imports System.Collections.Generic

Module Example

    Sub Main()

        ' Report
        Dim report As Siberix.Report.Report = New Siberix.Report.Report()

        ' Info
        report.Info.Title = "Example"
        report.Info.Author = "Siberix Technologies, Canada"
        report.Info.Creator = "Siberix Report Writer"
        report.Info.Copyright = "2003-2012 Siberix Technologies, Canada"

        ' Section
        Dim section As Siberix.Report.Section.ISection = report.AddSection()
        section.Size = Siberix.Report.PageSize.Letter
        section.Spacings.All = 35

        ' Styles
        Dim style1 As Siberix.Report.Text.Style = New Siberix.Report.Text.Style(New Siberix.Graphics.Fonts.Arial(12), Siberix.Graphics.Brushes.Black)
        Dim style2 As Siberix.Report.Text.Style = New Siberix.Report.Text.Style(New Siberix.Graphics.Fonts.Arial(10), Siberix.Graphics.Brushes.Red)

        ' Site
        Dim site As Siberix.Report.ISite = section.AddSite()
        site.Width = New Siberix.Report.RelativeWidth(100)
        site.Height = New Siberix.Report.RelativeHeight(100)
        site.Borders = New Siberix.Report.Borders(New Siberix.Graphics.Pen(Siberix.Graphics.Colors.Black, 1, Siberix.Graphics.DashStyle.Dot), 5)
        site.Paddings.All = 5

        Dim text As Siberix.Report.Text.IText = site.AddText(10, 10)
        text.Width = New Siberix.Report.DirectWidth(200)
        text.Style = style1
        text.Alignment = Siberix.Report.TextAlignment.Justify
        text.Spacings.All = 10
        text.AddContent("(Left:10, Top:10) ", style2)
        text.AddContent("Amarone is produced in the Veneto region of northern Italy using a unique winemaking technique. Newly harvested grapes are laid on straw mats and left to dry over the course of several months - resulting in a wine with a very distinctive ""raisiny"" flavor.")

        text = site.AddText(150, 150, 45)
        text.Width = New Siberix.Report.DirectWidth(200)
        text.Style = style1
        text.Alignment = Siberix.Report.TextAlignment.Justify
        text.Spacings.All = 10
        text.AddContent("(Left:150, Top:150, Angle:45) ", style2)
        text.AddContent("Amarone is produced in the Veneto region of northern Italy using a unique winemaking technique. Newly harvested grapes are laid on straw mats and left to dry over the course of several months - resulting in a wine with a very distinctive ""raisiny"" flavor.")

        text = site.AddText(250, 100, -15)
        text.Width = New Siberix.Report.DirectWidth(200)
        text.Style = style1
        text.Alignment = Siberix.Report.TextAlignment.Justify
        text.Spacings.All = 10
        text.AddContent("(Left:250, Top:100, Angle:-15) ", style2)
        text.AddContent("Amarone is produced in the Veneto region of northern Italy using a unique winemaking technique. Newly harvested grapes are laid on straw mats and left to dry over the course of several months - resulting in a wine with a very distinctive ""raisiny"" flavor.")

        Dim image As Siberix.Report.IImage = site.AddImage(New Siberix.Graphics.Image("../../image.jpg"), 335, 240, -35)
        image.Width = New Siberix.Report.DirectWidth(150)

        ' Publish
        report.Publish("Document.pdf", Siberix.Report.FileFormat.PDF)
        report.Publish("Document.xps", Siberix.Report.FileFormat.XPS)

        ' Save
        report.Save("Report.xml")

        ' View
        Dim process As System.Diagnostics.Process = New System.Diagnostics.Process()
        Dim info As System.Diagnostics.ProcessStartInfo = New System.Diagnostics.ProcessStartInfo("Document.pdf")
        process.StartInfo = info
        process.Start()

    End Sub

End Module
