Imports System
Imports System.Collections.Generic

Module Example

    Sub Main()

        ' Report
        Dim report As Siberix.Report.Report = New Siberix.Report.Report()

        ' Info
        report.Info.Title = "Example"
        report.Info.Author = "Siberix Technologies, Canada"
        report.Info.Creator = "Siberix Report Writer"
        report.Info.Copyright = "2003-2012 Siberix Technologies, Canada"

        ' Section
        Dim section As Siberix.Report.Section.ISection = report.AddSection()
        section.Size = Siberix.Report.PageSize.Letter
        section.Spacings.All = 35

        ' Styles
        Dim style1 As Siberix.Report.Text.Style = New Siberix.Report.Text.Style(New Siberix.Graphics.Fonts.Arial(12), Siberix.Graphics.Brushes.Black)
        Dim style2 As Siberix.Report.Text.Style = New Siberix.Report.Text.Style(New Siberix.Graphics.Fonts.Arial(12), Siberix.Graphics.Brushes.Red)

        ' Tree
        Dim tree As Siberix.Report.Tree.ITree = section.AddTree()
        tree.Indent = 20
        tree.Interval = 10
        tree.Lines.Pen = Siberix.Graphics.Pens.DarkBlue

        Dim text As Siberix.Report.Text.IText = tree.AddText()
        text.Style = style1
        text.AddContent("Root", style2)

        Dim node As Siberix.Report.Tree.INode = tree.AddNode()

        text = node.AddText()
        text.Style = style1
        text.AddContent("Node ")
        text.AddContent("1", style2)

        node = tree.AddNode()

        text = node.AddText()
        text.Style = style1
        text.AddContent("Node ")
        text.AddContent("2", style2)

        node = node.AddNode()

        text = node.AddText()
        text.Style = style1
        text.AddContent("Node ")
        text.AddContent("2.1", style2)

        node = tree.AddNode()

        text = node.AddText()
        text.Style = style1
        text.AddContent("Node ")
        text.AddContent("3", style2)

        ' Publish
        report.Publish("Document.pdf", Siberix.Report.FileFormat.PDF)
        report.Publish("Document.xps", Siberix.Report.FileFormat.XPS)

        ' Save
        report.Save("Report.xml")

        ' View
        Dim process As System.Diagnostics.Process = New System.Diagnostics.Process()
        Dim info As System.Diagnostics.ProcessStartInfo = New System.Diagnostics.ProcessStartInfo("Document.pdf")
        process.StartInfo = info
        process.Start()

    End Sub

End Module
