Imports System
Imports System.Collections.Generic

Module Example

    Sub Main()

        ' Report
        Dim report As Siberix.Report.Report = New Siberix.Report.Report()

        ' Info
        report.Info.Title = "Example"
        report.Info.Author = "Siberix Technologies, Canada"
        report.Info.Creator = "Siberix Report Writer"
        report.Info.Copyright = "2003-2012 Siberix Technologies, Canada"

        ' Section
        Dim section As Siberix.Report.Section.ISection = report.AddSection()
        section.Size = Siberix.Report.PageSize.Letter
        section.Spacings.All = 35

        ' Styles
        Dim style1 As Siberix.Report.Text.Style = New Siberix.Report.Text.Style(New Siberix.Graphics.Fonts.Arial(10), Siberix.Graphics.Brushes.Black)
        Dim style2 As Siberix.Report.Text.Style = New Siberix.Report.Text.Style(New Siberix.Graphics.Fonts.Arial(85), New Siberix.Graphics.SolidColorBrush(New Siberix.Graphics.Color(240, 240, 240)))

        ' Page Numbering
        Dim footer As Siberix.Report.Section.IFooter = section.AddFooter()
        footer.Height = New Siberix.Report.DirectHeight(30)

        Dim pn As Siberix.Report.IPageNumber = footer.AddPageNumber(600, 10)
        pn.Style = style1
        pn.Format = Siberix.Report.NumberFormat.Decimal
        pn.Template = "Page {0} of {1}"
        pn.Alignment = Siberix.Report.NumberAlignment.Right

        ' Watermark
        Dim watermark As Siberix.Report.Section.IWatermark = section.AddWatermark()
        watermark.Repeat = True

        Dim image As Siberix.Graphics.Image = New Siberix.Graphics.Image("../../bgimage.png")
        Dim img As Siberix.Report.IImage = watermark.AddImage(image, 0, 600)

        Dim text As Siberix.Report.Text.IText = watermark.AddText(200, 500, -45)
        text.Style = style2
        text.AddContent("Watermark")

        section.AddPageBreak()
        section.AddPageBreak()

        ' Publish
        report.Publish("Document.pdf", Siberix.Report.FileFormat.PDF)
        report.Publish("Document.xps", Siberix.Report.FileFormat.XPS)

        ' Save
        report.Save("Report.xml")

        ' View
        Dim process As System.Diagnostics.Process = New System.Diagnostics.Process()
        Dim info As System.Diagnostics.ProcessStartInfo = New System.Diagnostics.ProcessStartInfo("Document.pdf")
        process.StartInfo = info
        process.Start()

    End Sub

End Module
