Module Example

    Sub Main()

        ' Report
        Dim report As Siberix.Report.Report = New Siberix.Report.Report()

        ' Info
        report.Info.Title = "Example"
        report.Info.Author = "Siberix Technologies, Canada"
        report.Info.Creator = "Siberix Report Writer"
        report.Info.Copyright = "2003-2012 Siberix Technologies, Canada"

        ' Section
        Dim section As Siberix.Report.Section.ISection = report.AddSection()
        section.Size = Siberix.Report.PageSize.Letter
        section.Spacings.All = 35

        ' LEAF
        Dim document As Siberix.Readers.LEAF.IDocument = Siberix.Readers.LEAF.DocumentReader.Read("../../Example.leaf")

        ' Canvas
        Dim canvas As Siberix.Report.ICanvas = section.AddCanvas()
        canvas.Height = New Siberix.Report.RelativeHeight(100)

        ' Graphics
        Dim graphics As Siberix.Graphics.IGraphics = canvas.AsGraphics()
        graphics.Scale(0.5F, 0.5F)
        graphics.Translate(150, 50)
        graphics.Rotate(50, 50, 25)

        ' Page
        Dim page As Siberix.Readers.LEAF.IPage = document.Pages(0)
        page.Render(graphics)

        ' Publish
        report.Publish("Document.pdf", Siberix.Report.FileFormat.PDF)
        report.Publish("Document.xps", Siberix.Report.FileFormat.XPS)

        ' Save
        report.Save("Report.xml")

        ' View
        Dim process As System.Diagnostics.Process = New System.Diagnostics.Process()
        Dim info As System.Diagnostics.ProcessStartInfo = New System.Diagnostics.ProcessStartInfo("Document.pdf")
        process.StartInfo = info
        process.Start()

    End Sub

End Module
